<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 3.1 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="./">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">nightly-20250306-101218</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/nightly">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 3.1: Supervisory control loop</h1>
                    <p>
                        In supervisory control, an <em>uncontrolled system</em> is controlled by a <em>supervisory controller</em> that ensures its correct and safe operation.
                        The uncontrolled system is also called the <em>plant</em>.
                        It is the system that is to be controlled, as it is, so without the supervisory controller that controls it.
                        The plant may therefore exhibit undesired and unsafe behavior.
                        The supervisory controller restricts the plant's behavior, by disabling certain events in certain states, to ensure it never reaches states that are undesired or unsafe.
                        Together the plant and the supervisory controller form the <em>controlled system</em>.
                    </p>
                    <p>
                        The plant can be seen as a map with all the possible roads that can be taken.
                        The supervisory controller can then be seen as traffic lights at road intersections that turn red to prevent taking roads that should not be taken, because they are dangerous, lead to a dead end or don't lead to your destination.
                        Being at a certain intersection is then analogous to the state of a discrete event system.
                        A road between two intersection is analogous to a transition between two states.
                        And a traffic light turning red is analogous to disabling a certain event.
                    </p>
                    <p>
                        The supervisory controller should thus observe the events that are possible in the plant, and should be able to prevent some of these events from occurring.
                        This is also known as the supervisory control loop, as shown in the figure below.
                        The plant indicates events that are enabled in its current state.
                        The supervisor then decides for each event whether it is allowed to be executed or not.
                        The plant then executes one of the events that are enabled in its own state and are allowed by the supervisor.
                        The plant, from its new state, then again indicates which events are enabled, and so on.
                    </p>
                    <img src="images/supervisory-control-loop.png">

                    <h2>Restricted copy of the plant state space as supervisor</h2>
                    <p>
                        So, how does this work exactly?
                        How does the supervisor control the uncontrolled plant?
                        The simplest form of supervisor, the traditional one, is one that is a restricted version of the plant.
                        It has the same alphabet as the plant, but disables some of its behavior (prevents certain roads from being traveled).
                        Such a supervisor is an automaton representing the state space of the plant, as you computed in the previous module, but then with some states and transitions removed from it.
                        We saw an example of this in already in Module 1, where the plant of a bridge had the following behavior (but now with a marked state):
                    </p>
                    <img src="images/automaton-bridge-uncontrolled.png">
                    <p>
                        And the supervisor was a restricted version of that (now also with a marked state):
                    </p>
                    <img src="images/automaton-bridge-controlled.png">
                    <p>
                        Two states of the plant state space are unsafe, and are therefore not present in the supervisor.
                        And all transitions to these two states are not present either.
                        The supervisor thus only contains the safe part of the plant behavior.
                    </p>
                    <p>
                        The plant and supervisor together form the controlled system.
                        When the plant and supervisor automata are put together in a single model, this is a model of the controlled system.
                        In such a model, the plant and supervisor automata synchronize on shared events.
                        The plant can then only take an edge for an event if the supervisor can also take one, and thus the supervisor allows the event.
                        If they can both take an edge for an event, they together perform a transition for the event.
                    </p>
                    <p>
                        In cases where the supervisor automaton is purely a restricted version of the plant state space, the state space of the controlled system model is equal to that of the supervisor automaton.
                        The CIF event-based supervisor synthesis tool produces such supervisor automata.
                    </p>
                    <p>
                        It can also be that a supervisor automaton is derived in some other way, for instance manually.
                        It could be that it is then not a restriction of the plant state space, but still restricts the plant behavior in some way.
                        Still, in all cases, the plant together with the supervisor forms the controlled system.
                    </p>

                    <h2>Additional control conditions as supervisor</h2>
                    <p>
                        For very large plant state spaces, it is not very convenient to represent a supervisor as a restricted version of the plant's state space.
                        If it has thousands, millions or even billions of states, it would be hard to see what exactly is being restricted.
                        In such cases it is better to represent the supervisor as a smaller automaton.
                        The most extreme case for this is to represent the supervisor only as the extra control conditions that it imposes on the plant's behavior.
                        That is, the supervisor automaton has a single location that is initial and marked.
                        This location has for each restricted event a self-loop edge with as guard the extra control condition.
                        For the bridge example, such a supervisor could look like this:
                    </p>
                    <img src="images/automaton-bridge-control-conditions1.png">
                    <p>
                        To prevent going from the <em>ClosedGreen</em> state to the <em>PartiallyOpenGreen</em> state, the supervisor allows the <code>partially_opened</code> event only when not in the <em>ClosedGreen</em> state.
                        And to prevent going from the <em>PartiallyOpenRed</em> state to the <em>PartiallyOpenGreen</em> state, or from the <em>OpenRed</em> state to the <em>OpenGreen</em> state, the supervisor allows the <code>to_green</code> event only when in the <em>ClosedRed</em> state.
                        It is sufficient that the supervisor restricts going from a safe state to an unsafe one.
                        It does not have to prevent transitions between unsafe states, as the unsafe states can no longer be reached.
                    </p>
                    <p>
                        The controlled system still consists of the plant together with the supervisor.
                        If the plant and this new supervisor are put together in a model, they still synchronize on their shared events.
                        The supervisor thereby adds additional conditions, through the guards on the self-loop edges, to the behavior of the plant.
                        Only if the supervisor guards allow an event, can the plant and supervisor together take a transition for the event.
                        The events for which the supervisor does not have a self-loop edge are not in the alphabet of the supervisor.
                        The supervisor does not restrict such events, and the plant can take transitions for them by itself.
                    <p>
                    <p>
                        The behavior of this alternative controlled system is the same as for the previous controlled system.
                        That is, the state space of the plant together with this second supervisor is exactly the same as the supervisor automaton of the first supervisor.
                        The two supervisors are thus functionally equivalent.
                        The second supervisor however, more explicitly indicates what behavior of the plant it restricts.
                    <p>

                    <h2>Modeling plants and supervisors in CIF</h2>
                    <p>
                        When modeling for supervisory controller synthesis, the automata in a CIF model need be distinguished as being part of the plant or being a supervisor.
                        The <code>automaton</code> keyword can be replaced by <code>plant</code> to indicate that the automaton is a plant automaton.
                        The <code>automaton</code> keyword can also be replaced by <code>supervisor</code> to indicate that the automaton is a supervisor automaton.
                        Besides <code>plant</code> also <code>plant automaton</code> is allowed, and similarly <code>supervisor automaton</code> can also be used instead of <code>supervisor</code>.
                    </p>
                    <p>
                        For instance, the supervisor automaton above, the one with the additional control conditions as self loops, could be modeled in CIF as follows:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            supervisor s:
                                location:
                                    initial;
                                    marked;
                                    edge partially_opened when not ClosedGreen;
                                    edge to_green         when     ClosedRed;
                            end
                        </code>
                    </pre>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'multiple-choice',
                                question: "Which of the following statements are true?",
                                answers: [
                                    "The plant indicates what events are possible in the uncontrolled system, and the supervisor can allow or disallow them.",
                                    "The supervisor indicates what events are possible in the uncontrolled system, and the plant then executes one of those.",
                                    "The plant and supervisor always execute their events together."
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'multiple-choice',
                                question: "What is the controlled system?",
                                answers: [
                                    "The uncontrolled system under control of the supervisor.",
                                    "The plant and supervisor that synchronize on shared events.",
                                    "A safe version of the supervisor.",
                                ],
                                correctAnswer: '1, 2'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    Does the following supervisor control the bridge system in the same way as the first two supervisors presented in this sub-module?
                                    <img src="images/automaton-bridge-control-conditions2.png">
                                `,
                                answers: [
                                    "Yes.",
                                    "No.",
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    Does the following supervisor control the bridge system in the same way as the first two supervisors presented in this sub-module?
                                    <img src="images/automaton-bridge-control-conditions3.png">
                                `,
                                answers: [
                                    "Yes.",
                                    "No.",
                                ],
                                correctAnswer: '1'
                            }
                        ]
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="./">Go back to Module 3</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="synthesis-guarantees.html">Proceed to Module 3.2</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
